#include "X3D_X3DUrlObject.h"

namespace X3DTK {
namespace X3D {

X3DUrlObject::X3DUrlObject()
: X3DObject()
{
}

X3DUrlObject::X3DUrlObject(const X3DUrlObject &N)
: X3DObject(N), _url(N._url)
{
}

X3DUrlObject::~X3DUrlObject()
{
}

void X3DUrlObject::setUrl(const MFString &url)
{
  _url = url;
}

void X3DUrlObject::load(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("url");
  if (index != -1)
    _url = MFString(element->getAttribute(index));
}

SFString &X3DUrlObject::write(SFString &output) const
{
  if (!_url.empty())
    output += " url=\'" + toSFString(_url) + "\'";
        
  return output;
}

}
}
