#include "GL_RendererShapeVisitor.h"
#include "GL_Material.h"
#include "GL_X3DShapeNode.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace GL {

RendererShapeVisitor::RendererShapeVisitor()
: ShapeVisitor()
{
  // Enter functions.
  defineEnterFunction(&RendererShapeVisitor::enterMaterial);
  defineEnterFunction(&RendererShapeVisitor::enterX3DShapeNode);
}

void RendererShapeVisitor::enterMaterial(Material *M) 
{
  RendererStateVariables *stateVariables = GraphTraversal::getInstanceOf<RendererStateVariables>();
  
  glMaterialfv(GL_FRONT, GL_DIFFUSE, &M->getDiffuseColor().front());
  glMaterialfv(GL_FRONT, GL_AMBIENT, &M->getAmbientColor().front());
  glMaterialfv(GL_FRONT, GL_EMISSION, &M->getEmissiveColor().front());
  SFFloat s = M->getShininess();
  glMaterialfv(GL_FRONT, GL_SHININESS, &s); 
  glMaterialfv(GL_FRONT, GL_SPECULAR, &M->getSpecularColor().front());
}

void RendererShapeVisitor::enterX3DShapeNode(X3DShapeNode *N) 
{
  RendererStateVariables *stateVariables = GraphTraversal::getInstanceOf<RendererStateVariables>();
  if (stateVariables->getSelectionMode())
  {
    stateVariables->storeShape(N);
    glLoadName(stateVariables->getCurrentId());
//    cout << "loading name " << stateVariables->getCurrentId() << endl;
  }  
}

}
}
