#include "X3DComponentVisitor.h"
#include "EnterFunction.h"
#include "WalkOnFunction.h"
#include "LeaveFunction.h"

#include <algorithm>

using namespace X3DTK;
using namespace std;

X3DComponentVisitor::X3DComponentVisitor()
{
}

X3DComponentVisitor::~X3DComponentVisitor()
{
  //delete the functions
  for (EnterDict::iterator it = _enterDict.begin(); it != _enterDict.end(); ++it)
    delete (*it).second; 
  
  for (WalkOnDict::iterator it = _walkonDict.begin(); it != _walkonDict.end(); ++it)
    delete (*it).second; 

  for (LeaveDict::iterator it = _leaveDict.begin(); it != _leaveDict.end(); ++it)
    delete (*it).second; 
}

EnterFunction *X3DComponentVisitor::getEnterFunctionOf(const SFType *type) const
{
  SFString nodeName = type->getEncodedName();
  EnterDict::const_iterator it = _enterDict.find(nodeName);
  if (it != _enterDict.end())
  {
//    cout << this << " getEnterFunctionOf " << nodeName << " = "<< (*it).second << endl;
    return (*it).second;
  }  
  return 0;  
}

WalkOnFunction *X3DComponentVisitor::getWalkOnFunctionOf(const SFType *type) const
{
  SFString nodeName = type->getEncodedName();
  WalkOnDict::const_iterator it = _walkonDict.find(nodeName);
  if (it != _walkonDict.end())
    return (*it).second;
    
  return 0;  
}

LeaveFunction *X3DComponentVisitor::getLeaveFunctionOf(const SFType *type) const
{ 
  SFString nodeName = type->getEncodedName();
  LeaveDict::const_iterator it = _leaveDict.find(nodeName);
  if (it != _leaveDict.end())
    return (*it).second;
    
  //not found  
  return 0;  
}
